<template>
  <div class="grid-effectif" :style="`--progress-size: ${progressSize}`">
    <div class="is-size-7  mt-font">
      <span class="is-hidden-mobile">{{ pax.corps.libelle }}</span
      ><span class="is-hidden-tablet">{{ pax.corps.code }}</span>
    </div>
    <b-progress :type="typeFromPercent" :value="percentSubscribed" v-bind="$attrs" />
    <div class="is-size-7 mt-font">{{ pax.avancement.nombre }} / {{ pax.avancement.total }}</div>
    <div class="is-size-7 mt-font">
      <span v-if="compterPaxSuplementaire() > 0" class="effectifSuplementaire"> + {{ compterPaxSuplementaire() }}</span>
    </div>
  </div>
</template>

<script>
export default {
  name: 'MtProgressPaxSub',
  inheritAttrs: false,
  props: {
    pax: {
      type: Object,
      default: () => {},
    },
    progressSize: {
      type: String,
      default: '166px',
    },
  },
  computed: {
    percentSubscribed() {
      if (this.pax.nombre < this.pax.avancement.nombre || this.pax.nombre === 0) {
        this.changePourcentage();
        return this.pax.avancement.pourcentage;
      }
      return this.pax.avancement.pourcentage;
    },
    typeFromPercent() {
      if (this.percentSubscribed >= 0 && this.percentSubscribed <= 33) {
        return 'is-danger';
      }
      if (this.percentSubscribed > 33 && this.percentSubscribed <= 66) {
        return 'is-warning';
      }
      if (this.percentSubscribed < 100) {
        return 'is-success';
      }
      return 'is-info';
    },
  },
  methods: {
    changePourcentage() {
      this.pax.avancement.pourcentage = 100;
    },
    compterPaxSuplementaire() {
      return (this.pax.avancement.total - this.pax.avancement.nombre) * -1;
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.effectifSuplementaire {
  padding-left: 0.25rem;
  padding-right: 0.25rem;
  margin-left: 0.3rem;
  border-radius: 2rem;
  color: $blue;
  background-color: $pale-grey;
}
.grid-effectif {
  display: grid;
  grid-template-columns: 1fr var(--progress-size) 2em 2em;
  grid-gap: 0 0.5em;
  text-transform: uppercase;
  margin: 0.25rem 1rem;
  text-align: left;
  min-width: 300px;
  align-items: center;
}
.mt-font {
  color: $grey-dark;
  font-weight: bold;
}
/deep/ {
  .progress {
    height: 0.5rem;
    font-weight: bold;
  }
  .progress-wrapper:not(:last-child) {
    margin-bottom: 0;
  }
}
@media screen and (max-width: 768px) {
  .grid-effectif {
    --progress-size: 100px !important;
    min-width: auto;
  }
}
</style>
